<?php
/**
 * @package   Essentials YOOtheme Pro 2.2.16 build 0813.1608
 * @author    ZOOlanders https://www.zoolanders.com
 * @copyright Copyright (C) Joolanders, SL
 * @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 */

namespace ZOOlanders\YOOessentials\Source\Provider\Rss\Type;

use ZOOlanders\YOOessentials\Source\GraphQL\TypeInterface;

class RssLinkType implements TypeInterface
{
    public const NAME = 'RSSLink';

    public function type(): string
    {
        return TypeInterface::TYPE_OBJECT;
    }

    public function label(): string
    {
        return 'Link';
    }

    public function name(): string
    {
        return self::NAME;
    }

    public function config(): array
    {
        return [
            'fields' => [
                'url' => [
                    'type' => 'String',
                    'metadata' => [
                        'label' => 'URL',
                        'fields' => [],
                    ],
                ],
                'rel' => [
                    'type' => 'String',
                    'metadata' => [
                        'label' => 'Rel',
                        'fields' => [],
                    ],
                ],
            ],
            'metadata' => [
                'type' => true,
                'label' => $this->label(),
            ],
        ];
    }

    public static function resolve($data, $args): array
    {
        $link = $data[$args['header']] ?? [];

        $link['url'] = urldecode($link['url'] ?? ($link['href'] ?? ''));

        return $link;
    }
}
